# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2012 Cubic ERP - Teradata SAC (<http://cubicerp.com>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv
import time
import logging
_logger = logging.getLogger(__name__)

class account_voucher(osv.osv):
    _name = 'account.voucher'
    _inherit = 'account.voucher'
    _columns = {
            'analytics_id': fields.many2one('account.analytic.plan.instance', 'Analytic Distribution', readonly=True, states={'draft':[('readonly',False)]}),
        }

    def onchange_journal(self, cr, uid, ids, journal_id, line_ids, tax_id, partner_id, date, amount, ttype, company_id, context=None):
        res = super(account_voucher,self).onchange_journal(cr, uid, ids, journal_id, line_ids, tax_id, partner_id, date, amount, ttype, company_id, context=context)
        analytics_id = self.pool.get('account.analytic.default').account_get(cr, uid, False, partner_id, uid, time.strftime('%Y-%m-%d'), context={})
        _logger.debug("res:%s - analytics_id:%s"%(res,analytics_id))
        if not res:
            res = {'value':{}}
        res['value'].update({'analytics_id':analytics_id and analytics_id.id})
            
        return res
        
    def onchange_partner_id(self, cr, uid, ids, partner_id, journal_id, amount, currency_id, ttype, date, context=None):
        res = super(account_voucher,self).onchange_partner_id(cr, uid, ids, partner_id, journal_id, amount, currency_id, ttype, date, context=context)
        analytics_id = self.pool.get('account.analytic.default').account_get(cr, uid, False, partner_id, uid, time.strftime('%Y-%m-%d'), context={})
        if not res:
            res = {'value':{}}
        res['value'].update({'analytics_id':analytics_id and analytics_id.id})
        return res

    '''def voucher_move_line_create(self, cr, uid, voucher_id, line_total, move_id, company_currency, current_currency, context=None):
        line_total, rec_list_ids = super(account_voucher,self).voucher_move_line_create(cr, uid, voucher_id, line_total, move_id, company_currency, current_currency, context=context)
        _logger.info("line_total:%s - rec_list_ids:%s"%(line_total, rec_list_ids))
        voucher_brw = self.pool.get('account.voucher').browse(cr, uid, voucher_id, context)
        line_obj = self.pool.get('account.move.line')
        for rec_ids in rec_list_ids:
            for line in line_obj.browse(cr, uid, rec_ids, context=context):
                _logger.info("line.account_id.type:%s - voucher_brw.analytics_id:%s"%(line.account_id.type,voucher_brw.analytics_id))
                if line.account_id.type in ('liquidity') and voucher_brw.analytics_id:
                    line_obj.write(cr, uid, [line.id], {'analytics_id':voucher_brw.analytics_id.id}, context=context)

        return (line_total, rec_list_ids)'''

    def first_move_line_get(self, cr, uid, voucher_id, move_id, company_currency, current_currency, context=None):
        res = super(account_voucher,self).first_move_line_get(cr, uid, voucher_id, move_id, company_currency, current_currency, context=context)
        voucher_brw = self.pool.get('account.voucher').browse(cr, uid, voucher_id, context)
        if voucher_brw.analytics_id:
            res['analytics_id'] = voucher_brw.analytics_id.id
        
        return res

account_voucher()