# -*- coding: utf-8 -*-
##############################################################################
#
#    Copyright (C) Javier Duran
#                  Mariano Ruiz (Enterprise Objects Consulting)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields
from osv import osv

class product_product(osv.osv):
    _inherit = 'product.product'
    
    def name_search(self, cr, user, name='', args=None, operator='ilike', context=None, limit=100):
        ids=[]
        if not args:
            args=[]
        if not context:
            context={}
        if context and context.has_key('partner_id') and context['partner_id']:
            # Warn: ps.name is the pk of the partner in the product_supplierinfo model
            cr.execute('SELECT p.id ' \
                    'FROM product_product AS p ' \
                    'INNER JOIN product_template AS t ' \
                    'ON p.product_tmpl_id=t.id ' \
                    'INNER JOIN product_supplierinfo AS ps ' \
                    'ON ps.product_id=t.id ' \
                    'WHERE ps.name = %s ' \
                    'AND ps.product_code = %s ' \
                    'AND t.purchase_ok = True ' \
                    'ORDER BY p.id',
                    (context['partner_id'],name))
            res = cr.fetchall()
            ids = map(lambda x:x[0], res)
            if not len(ids):
                cr.execute('SELECT p.id ' \
                    'FROM product_product AS p ' \
                    'INNER JOIN product_template AS t ' \
                    'ON p.product_tmpl_id=t.id ' \
                    'INNER JOIN product_supplierinfo AS ps ' \
                    'ON ps.product_id=t.id ' \
                    'WHERE ps.name = %s ' \
                    'AND ps.product_name = %s ' \
                    'AND t.purchase_ok = True ' \
                    'ORDER BY p.id',
                    (context['partner_id'],name ))
                res = cr.fetchall()
                ids = map(lambda x:x[0], res)
            if not len(ids):
                cr.execute('SELECT p.id ' \
                    'FROM product_product AS p ' \
                    'INNER JOIN product_template AS t ' \
                    'ON p.product_tmpl_id=t.id ' \
                    'INNER JOIN product_supplierinfo AS ps ' \
                    'ON ps.product_id=t.id ' \
                    'WHERE ps.name = %s ' \
                    'AND p.ean13 = %s ' \
                    'AND t.purchase_ok = True ' \
                    'ORDER BY p.id',
                    (context['partner_id'],name ))
                res = cr.fetchall()
                ids = map(lambda x:x[0], res)
            if not len(ids):
                if operator in ('like', 'ilike'):
                    name='%'+name+'%'
                cr.execute('SELECT p.id ' \
                    'FROM product_product AS p ' \
                    'INNER JOIN product_template AS t ' \
                    'ON p.product_tmpl_id=t.id ' \
                    'INNER JOIN product_supplierinfo AS ps ' \
                    'ON ps.product_id=t.id ' \
                    'WHERE ps.name = %s ' \
                    'AND ps.product_code '+operator+' %s ' \
                    'AND t.purchase_ok = True ' \
                    'ORDER BY p.id',
                    (context['partner_id'],name ))
                res = cr.fetchall()
                ids = map(lambda x:x[0], res)
                ids = set(ids)
                cr.execute('SELECT p.id ' \
                    'FROM product_product AS p ' \
                    'INNER JOIN product_template AS t ' \
                    'ON p.product_tmpl_id=t.id ' \
                    'INNER JOIN product_supplierinfo AS ps ' \
                    'ON ps.product_id=t.id ' \
                    'WHERE ps.name = %s ' \
                    'AND ps.product_name '+operator+' %s ' \
                    'AND t.purchase_ok = True ' \
                    'ORDER BY p.id',
                    (context['partner_id'],name ))
                res = cr.fetchall()
                ids.update(map(lambda x:x[0], res))
            if not len(ids):
                if operator in ('like', 'ilike'):
                    name='%'+name+'%'
                cr.execute('SELECT p.id ' \
                    'FROM product_product AS p ' \
                    'INNER JOIN product_template AS t ' \
                    'ON p.product_tmpl_id=t.id ' \
                    'INNER JOIN product_supplierinfo AS ps ' \
                    'ON ps.product_id=t.id ' \
                    'WHERE ps.name = %s ' \
                    'AND p.default_code '+operator+' %s ' \
                    'AND t.purchase_ok = True ' \
                    'ORDER BY p.id',
                    (context['partner_id'],name ))
                res = cr.fetchall()
                ids = map(lambda x:x[0], res)
                ids = set(ids)
                cr.execute('SELECT p.id ' \
                    'FROM product_product AS p ' \
                    'INNER JOIN product_template AS t ' \
                    'ON p.product_tmpl_id=t.id ' \
                    'INNER JOIN product_supplierinfo AS ps ' \
                    'ON ps.product_id=t.id ' \
                    'WHERE ps.name = %s ' \
                    'AND t.name '+operator+' %s ' \
                    'AND t.purchase_ok = True ' \
                    'ORDER BY p.id',
                    (context['partner_id'],name ))
                res = cr.fetchall()
                ids.update(map(lambda x:x[0], res))
        if isinstance(ids, set):
            ids = list(ids)
        ids = list(ids)
        if not len(ids):
            ids = self.search(cr, user, [('default_code','=',name)]+ args, limit=limit, context=context)
        if not len(ids):
            ids = self.search(cr, user, [('ean13','=',name)]+ args, limit=limit, context=context)
        if not len(ids):
            ids = self.search(cr, user, [('default_code',operator,name)]+ args, limit=limit, context=context)
            ids += self.search(cr, user, [('name',operator,name)]+ args, limit=limit, context=context)
            ids = list(set(ids))
        result = self.name_get(cr, user, ids, context)
        return result

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        if context and context.get('purchase_supplier', False):
            # Fix a infrequent error in some installations...
            purchase_ok_set = False
            args2 = []
            for arg in args:
                if arg[0] == 'seller_ids':
                    # Replace seller_ids argument
                    args2.append(['purchase_ok', '=', True])
                    purchase_ok_set = True
                else:
                    args2.append(arg)
            if not purchase_ok_set:
                args2.append(['purchase_ok', '=', True])
        else:
            args2 = args
        result = super(product_product, self).search(cr, uid, args2, offset, limit, order, context, count)
        return result

product_product()


class product_supplierinfo(osv.osv):
    _inherit = "product.supplierinfo"

    _columns = {
            'url': fields.char('URL', size=1000),
    }

    _defaults = {
        'min_qty': lambda *a: 1.0,
    }

product_supplierinfo()
